﻿if not (bit and jit) then return end

local ffi=require'ffi'
local C=ffi.C
local band,bor = bit.band,bit.bor
local tonumber = tonumber
local CompareStringFlags = bor(C.NORM_IGNORECASE, C.SORT_STRINGSORT)
local DOT, BS = string.byte("."), string.byte("\\")

--------------------------------------------------------------------------------
-- Helper functions.
--------------------------------------------------------------------------------

ffi.cdef[[
wchar_t* wcschr(const wchar_t*, wchar_t);
wchar_t* wcsrchr(const wchar_t*, wchar_t);
]]

local function getName (fullname)
  local bs = C.wcsrchr(fullname,BS)
  return bs ~= nil and bs+1 or fullname
end

--------------------------------------------------------------------------------
-- Custom sort modes.
--------------------------------------------------------------------------------

local modeName, descName = 210, "Custom: by name (first dot)"

local function CompareByName(p1,p2,opt)
  local name1, name2 = getName(p1.FileName), getName(p1.FileName)
  local ext1, ext2 = C.wcschr(name1,DOT), C.wcschr(name2,DOT)
  local len1 = ext1~=nil and ext1-name1 or -1
  local len2 = ext2~=nil and ext2-name2 or -1
  return -2 + C.CompareStringW(C.LOCALE_USER_DEFAULT, CompareStringFlags, name1, len1, name2, len2)
end

Panel.LoadCustomSortMode (modeName, {
  Description = descName; Indicator = "юЮ";
  Compare = CompareByName;
})

--------------------------------------------------------------------------------
-- Macros.
--------------------------------------------------------------------------------

Macro {
  description = descName;
  area="Shell"; key="CtrlShiftF3";
  action=function()
    --local t1=Far.UpTime
    Panel.SetCustomSortMode(modeName)
    --far.Message(Far.UpTime-t1, "benchmark")
  end;
}
